package p2pcdnsim.cdn;

import desmoj.core.simulator.SimTime;

public interface CachingStrategy<T extends ObjectContent> {

	public T retrieveObject(long objectId, SimTime timeStamp);

	public boolean insertObject(T content, SimTime currentTime);

	public void setCacheSize(long size);

}
