package simtools.xml.test;

import java.io.*;
import java.util.List;
import java.util.Iterator;
import org.jdom.*;
import org.jdom.input.SAXBuilder;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

public class MyTest {
	
    // Download and Process XML File
	public void process(String url) {
		try {
			SAXBuilder builder = new SAXBuilder();
			Document doc = builder.build(new File(url));
			//extractNewsStories(doc);
			
			Alterardados(doc);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void escrever(Element root) {
		try {
			Format format = Format.getPrettyFormat();
            format.setLineSeparator("\n");
            
			XMLOutputter out = new XMLOutputter(format);
			out.output(root, System.out);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	@SuppressWarnings("unchecked")
	private void Alterardados(Document doc) {
		Element root = doc.getRootElement();
		List<Element> links = root.getChildren("Link");
		Iterator<Element> i = links.iterator();
		
		Element temp = new Element("Links");
		Element x;
		
		while (i.hasNext()) {
			Element link = i.next();
			Element linkSpeed = link.getChild("LinkSpeed");
			
			x = (Element) link.clone();
			
			if (linkSpeed.getText().equals("null")) {
				x.getChild("LinkSpeed").setText("1000");
				x.getChild("Delay").setText("10");
				x.getChild("Queue").setText("bla");
			}
			temp.addContent(x);
		}
		
		escrever(temp);
		//extractNewsStories2(temp);
	}
	
	public static void main(String[] args) {
		MyTest app = new MyTest();
		app.process(
				"C:/Kalil/workspace/TxtToXml/src/Routers.xml");
	}
}
